Sponsored Content
Top Forums UNIX for Beginners Questions & Answers Bash Variable scope - while loop while reading from a file Post 303037381 by bakunin on Wednesday 31st of July 2019 02:39:50 AM
Old 07-31-2019
Quote:
Originally Posted by wisecracker
As is often the case with a little bit of jiggery pokery there is a pseudo-back-door.
This is especially for you:

Code:
#! /bin/bash

pInitPermStor ()
{
if [ ! -d "$fStorage" ] ; then
     return $(mkdir -p "$fStorage")            # create storage dir if not there
fi

return $(rm -f "$fStorage/*")                  # empty it if it already exists
}




pRemovePermStor ()
{
if [ ! -d "$fStorage" ] ; then
     return 1                                  # shouldn't happen
fi

return $(rm -f "$fStorage")                    # clean up
}




pGetVar ()
{
local chVar="$1"

if [ -f "${fStorage}/${chVar}" ] ; then
     printf "%s=%s\n" "$chVar" $( < "${fStorage}/${chVar}" )
else
     printf "$chVar"=\"\"
fi

return 0
}


pPutVar ()
{
local chVar="$1"
local chValue="$2"

if ! printf "%s\n" "$2" > "${fStorage}/${chVar}" ; then
     return 1
fi

return 0
}


# ------------------ main()
declare fStorage="/path/to/dir/$$"

if ! pInitPermStor ; then
     printf "ERROR: cannot initialise permanent variable storage\n" >&2
     exit 1
fi

pPutVar "x" "abcd"             # set value of variable x to "abcd"
eval $( pGetVar "x" )          # retrieve and set variable x
echo var x is: $x

if ! pRemovePermStor ; then
     printf "ERROR: permanent variable storage not found\n" >&2
     exit 1
fi
exit 0

ROFL, i doubt this helps anyone but it was fun to write.

bakunin

/edited following MadeInGermanys suggestion

Last edited by bakunin; 07-31-2019 at 10:19 AM..
 

10 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

bash and ksh: variable lost in loop in bash?

Hi, I use AIX (ksh) and Linux (bash) servers. I'm trying to do scripts to will run in both ksh and bash, and most of the time it works. But this time I don't get it in bash (I'm more familar in ksh). The goal of my script if to read a "config file" (like "ini" file), and make various report.... (2 Replies)
Discussion started by: estienne
2 Replies

2. UNIX for Dummies Questions & Answers

reading more than one variable into a for loop

Hi, I have a file (details.txt) with 3 rows of variables ie... name postcode age john D fr25dd 25 mark W ab122aa 22 phil C cd343bb 33 What I want to do is read down the list with a loop and add each field into a one line piece of text... So I have a file (test1) which reads;... (3 Replies)
Discussion started by: starsky
3 Replies

3. Shell Programming and Scripting

Not access variable outside loop when a reading a file

I am writing a shell script using the korn shell. It seems that I am only able to use local variables within a while loop that is reading a file. (I can't access a variable outside a previously used while loop.) It's been a while since I wrote shell scripts. Here is a sample cat file.txt... (4 Replies)
Discussion started by: ricardo.ludwig
4 Replies

4. Shell Programming and Scripting

How to get the modified value of variable outside the while loop reading from a file

Hi Friends , Sorry if this is a repeated question , The input file contains 5 lines , so the the values of the variables i and count should b i=5; count=15 but the variables are not updating , the value of variables showing i=0 and count =0 only.:mad: can any1 help me please. (11 Replies)
Discussion started by: babusek
11 Replies

5. Shell Programming and Scripting

Bourne Shell - Problem with while loop variable scope.

Hello I am having issues with a script I'm working on developing on a Solaris machine. The script is intended to find out how many times a particular user (by given userid) has logged into the local system for more than one hour today. Here is my while loop: last $user | grep -v 'sshd'... (7 Replies)
Discussion started by: DaveRich
7 Replies

6. UNIX for Dummies Questions & Answers

Bash loops and variable scope

Hi All, I've been researching this problem and I am pretty sure that the issue is related to the while loop and the piping. There are plenty of other threads about this issue that recommend removing the pipe and using redirection. However, I haven't been able to get it working using the ssh and... (1 Reply)
Discussion started by: 1skydive
1 Replies

7. Shell Programming and Scripting

(BASH) Using a loop variable to grep something in a file?

Hi, I have a loop running until a variable L that is read previously in the full script. I'd like to grep some information in an input file at a line that contains the value of the loop parameter $i. I've tried to use grep, but the problem is nothing is written in the FILE files. It seems grep... (5 Replies)
Discussion started by: DMini
5 Replies

8. Shell Programming and Scripting

Variable scope in bash

Hello! Before you "bash" me with - Not another post of this kind Please read on and you will understand my problem... I am using the below to extract a sum of the diskIO on a Solaris server. #!/bin/sh PATH=/usr/bin:/usr/sbin:/sbin; export PATH TEMP1="/tmp/raw-sar-output.txt$$"... (3 Replies)
Discussion started by: haaru
3 Replies

9. Shell Programming and Scripting

Detail on For loop for multiple file input and bash variable usage

Dear mentors, I just need little explanation regarding for loop to give input to awk script for file in `ls *.txt |sort -t"_" -k2n,2`; do awk script $file done which sorts file in order, and will input one after another file in order to awk script suppose if I have to input 2 or... (4 Replies)
Discussion started by: Akshay Hegde
4 Replies

10. Shell Programming and Scripting

BASH: variable and function scope and subscripts

Hi, I'm a Delphi developer new to linux, new to this forums and new to BASH programming and got a new task in my work: maintaining an existing set of BASH scripts. First thing I want to do is making the code more reliable as in my opinion it's really bad written. So here's the quest: I'm... (6 Replies)
Discussion started by: rse
6 Replies
setjmp(3)						     Library Functions Manual							 setjmp(3)

Name
       setjmp, longjmp - non-local goto

Syntax
       #include <setjmp.h>

       int setjmp (env)
       jmp_buf env;

       void longjmp (env, val)
       jmp_buf env;
       int val;

Description
       The and functions help deal with errors and interrupts encountered in a low-level subroutine of a program.

       The function saves its stack environment in env (whose type, jmp_buf, is defined in the <setjmp.h> header file) for later use by It returns
       the value 0.

       The function restores the environment saved by the last call of with the corresponding env argument.   After  finishes,	program  execution
       continues  as if the corresponding call of (which must not itself have returned in the interim) had just returned the value val.  The func-
       tion cannot cause to return the value 0.  If is invoked with a second argument of 0, returns 1.	At the time of the second return from  all
       accessible  data  have  values as of the time is called.  However, global variables have the expected values.  For example, those as of the
       time of the

Examples
       #include <setjmp.h>

       jmp_buf env;
       int i = 0;
       main ()
       {
	    void exit();

	    if(setjmp(env) != 0) {
		 (void) printf("value of i on 2nd return from setjmp: %d0, i);
		 exit(0);
	    }
	    (void) printf("value of i on 1st return from setjmp: %d0, i);
	    i = 1;
	    g();
	    /*NOTREACHED*/
       }

       g()
       {
	    longjmp(env, 1);
	    /*NOTREACHED*/
       }

       If the a.out resulting from this C language code is run, the output is as follows:
       value of i on 1st return from setjmp:0

       value of i on 2nd return from setjmp:1
       Unexpected behavior occurs if is called without a previous call to or when the last such call was in a function which has since returned.

Restrictions
       The values of the registers on the second return from are register values at the time of the first call to not those of the Thus, variables
       in a given function can produce unexpected results in the presence of depending on whether they are register or stack variables.

See Also
       signal(2).

								       RISC								 setjmp(3)
All times are GMT -4. The time now is 04:12 PM.
Unix & Linux Forums Content Copyright 1993-2022. All Rights Reserved.
Privacy Policy